## nebula 1.2.0

=== DESCRIPTION ===
Package: nebula
Type: Package
Title: Negative Binomial Mixed Models Using Large-Sample Approximation
        for Differential Expression Analysis of ScRNA-Seq Data
Version: 1.2.0
Date: 2022-01-19
Author: Liang He
Maintainer: Liang He <liang.he@duke.edu>
Description: A fast negative binomial mixed model for conducting association analysis of multi-subject single-cell data. It can be used for identifying marker genes, differential expression and co-expression analyses. The model includes subject-level random effects to account for the hierarchical structure in multi-subject single-cell data. See He et al. (2021) <doi:10.1038/s42003-021-02146-6>.  
License: GPL-3
Encoding: UTF-8
LazyData: true
Imports: Rcpp (>= 1.0.7), nloptr, MASS, stats, Matrix, methods, utils,
        Rfast, trust
LinkingTo: Rcpp, RcppEigen
Depends: R (>= 4.1)
RoxygenNote: 7.1.2
Suggests: knitr, rmarkdown
VignetteBuilder: knitr
NeedsCompilation: yes
Packaged: 2022-01-20 16:10:36 UTC; helia
Repository: CRAN
Date/Publication: 2022-01-21 09:02:45 UTC

## nebula 1.2.2

=== DESCRIPTION ===
Package: nebula
Type: Package
Title: Negative Binomial Mixed Models Using Large-Sample Approximation
        for Differential Expression Analysis of ScRNA-Seq Data
Version: 1.2.2
Date: 2023-01-09
Author: Liang He
Maintainer: Liang He <lianghe@health.sdu.dk>
Description: A fast negative binomial mixed model for conducting association analysis of multi-subject single-cell data. It can be used for identifying marker genes, differential expression and co-expression analyses. The model includes subject-level random effects to account for the hierarchical structure in multi-subject single-cell data. See He et al. (2021) <doi:10.1038/s42003-021-02146-6>.  
License: GPL-3
Encoding: UTF-8
LazyData: true
Imports: Rcpp (>= 1.0.7), nloptr, MASS, stats, Matrix, methods, utils,
        Rfast, trust
LinkingTo: Rcpp, RcppEigen
Depends: R (>= 4.1)
RoxygenNote: 7.2.1
Suggests: knitr, rmarkdown
VignetteBuilder: knitr
NeedsCompilation: yes
Packaged: 2023-01-18 17:52:23 UTC; helia
Repository: CRAN
Date/Publication: 2023-01-18 21:00:02 UTC

## nebula 1.4.2

=== DESCRIPTION ===
Package: nebula
Type: Package
Title: Negative Binomial Mixed Models Using Large-Sample Approximation
        for Differential Expression Analysis of ScRNA-Seq Data
Version: 1.4.2
Date: 2023-07-03
Author: Liang He
Maintainer: Liang He <hyx520101@gmail.com>
Description: A fast negative binomial mixed model for conducting association analysis of multi-subject single-cell data. It can be used for identifying marker genes, differential expression and co-expression analyses. The model includes subject-level random effects to account for the hierarchical structure in multi-subject single-cell data. See He et al. (2021) <doi:10.1038/s42003-021-02146-6>.  
License: GPL-3
Encoding: UTF-8
LazyData: true
Imports: Rcpp (>= 1.0.7), nloptr, stats, Matrix, methods, RSpectra,
        Rfast, trust, doFuture (>= 0.12.2), future (>= 1.32.0), foreach
        (>= 1.5.2), doRNG (>= 1.8.6)
LinkingTo: Rcpp, RcppEigen
Depends: R (>= 4.1)
RoxygenNote: 7.2.3
Suggests: knitr, utils, rmarkdown
VignetteBuilder: knitr
NeedsCompilation: yes
Packaged: 2023-07-05 20:33:41 UTC; helia
Repository: CRAN
Date/Publication: 2023-07-05 23:20:07 UTC

## nebula 1.5.3

=== DESCRIPTION ===
Package: nebula
Type: Package
Title: Negative Binomial Mixed Models Using Large-Sample Approximation
        for Differential Expression Analysis of ScRNA-Seq Data
Version: 1.5.3
Date: 2024-02-15
Authors@R: c(
    person("Liang", "He", email = "hyx520101@gmail.com", role = c("aut", "cre")),
    person("Raghav", "Sharma", email = "raghavv.sharma@mail.utoronto.ca", role = "ctb"))
Maintainer: Liang He <hyx520101@gmail.com>
Description: A fast negative binomial mixed model for conducting association analysis of multi-subject single-cell data. It can be used for identifying marker genes, differential expression and co-expression analyses. The model includes subject-level random effects to account for the hierarchical structure in multi-subject single-cell data. See He et al. (2021) <doi:10.1038/s42003-021-02146-6>.  
License: GPL-3
Encoding: UTF-8
LazyData: true
Imports: Rcpp (>= 1.0.7), nloptr, stats, Matrix, methods, Rfast, trust,
        parallelly (>= 1.34.0), doFuture (>= 0.12.2), future (>=
        1.32.0), foreach (>= 1.5.2), doRNG (>= 1.8.6), Seurat,
        SingleCellExperiment
LinkingTo: Rcpp, RcppEigen
Depends: R (>= 4.1)
RoxygenNote: 7.3.1
URL: https://github.com/lhe17/nebula
BugReports: https://github.com/lhe17/nebula/issues
Suggests: knitr, utils, rmarkdown
VignetteBuilder: knitr
NeedsCompilation: yes
Packaged: 2024-02-15 22:27:18 UTC; helia
Author: Liang He [aut, cre],
  Raghav Sharma [ctb]
Repository: CRAN
Date/Publication: 2024-02-15 23:00:02 UTC

## nebula 1.5.6

=== DESCRIPTION ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Type: Package
 Title: Negative Binomial Mixed Models Using Large-Sample Approximation
         for Differential Expression Analysis of ScRNA-Seq Data
-Version: 1.5.3
-Date: 2024-02-15
+Version: 1.5.6
+Date: 2025-11-28
 Authors@R: c(
     person("Liang", "He", email = "hyx520101@gmail.com", role = c("aut", "cre")),
     person("Raghav", "Sharma", email = "raghavv.sharma@mail.utoronto.ca", role = "ctb"))
@@ -24,8 +24,8 @@
 Suggests: knitr, utils, rmarkdown
 VignetteBuilder: knitr
 NeedsCompilation: yes
-Packaged: 2024-02-15 22:27:18 UTC; helia
+Packaged: 2025-11-28 19:30:07 UTC; helia
 Author: Liang He [aut, cre],
   Raghav Sharma [ctb]
 Repository: CRAN
-Date/Publication: 2024-02-15 23:00:02 UTC
+Date/Publication: 2025-12-07 07:00:15 UTC

## nebula 1.6.1+dfsg

=== Makefile ===
GOMINVERSION = 1.18
NEBULA_CMD_PATH = "./cmd/nebula"
GO111MODULE = on
export GO111MODULE
CGO_ENABLED = 0
export CGO_ENABLED

# Set up OS specific bits
ifeq ($(OS),Windows_NT)
	#TODO: we should be able to ditch awk as well
	GOVERSION := $(shell go version | awk "{print substr($$3, 3)}")
	GOISMIN := $(shell IF "$(GOVERSION)" GEQ "$(GOMINVERSION)" ECHO 1)
	NEBULA_CMD_SUFFIX = .exe
	NULL_FILE = nul
else
	GOVERSION := $(shell go version | awk '{print substr($$3, 3)}')
	GOISMIN := $(shell expr "$(GOVERSION)" ">=" "$(GOMINVERSION)")
	NEBULA_CMD_SUFFIX =
	NULL_FILE = /dev/null
endif

# Only defined the build number if we haven't already
ifndef BUILD_NUMBER
	ifeq ($(shell git describe --exact-match 2>$(NULL_FILE)),)
		BUILD_NUMBER = $(shell git describe --abbrev=0 --match "v*" | cut -dv -f2)-$(shell git branch --show-current)-$(shell git describe --long --dirty | cut -d- -f2-)
	else
		BUILD_NUMBER = $(shell git describe --exact-match --dirty | cut -dv -f2)
	endif
endif

LDFLAGS = -X main.Build=$(BUILD_NUMBER)

ALL_LINUX = linux-amd64 \
	linux-386 \
	linux-ppc64le \
	linux-arm-5 \
	linux-arm-6 \
	linux-arm-7 \
	linux-arm64 \
	linux-mips \
	linux-mipsle \
	linux-mips64 \
	linux-mips64le \
	linux-mips-softfloat \
	linux-riscv64

ALL = $(ALL_LINUX) \
	darwin-amd64 \
	darwin-arm64 \
	freebsd-amd64 \
	windows-amd64 \
	windows-arm64

e2e:
	$(TEST_ENV) go test -tags=e2e_testing -count=1 $(TEST_FLAGS) ./e2e

e2ev: TEST_FLAGS = -v
e2ev: e2e

e2evv: TEST_ENV += TEST_LOGS=1
e2evv: e2ev

e2evvv: TEST_ENV += TEST_LOGS=2
e2evvv: e2ev

e2evvvv: TEST_ENV += TEST_LOGS=3
e2evvvv: e2ev

e2e-bench: TEST_FLAGS = -bench=. -benchmem -run=^$
e2e-bench: e2e

all: $(ALL:%=build/%/nebula) $(ALL:%=build/%/nebula-cert)

release: $(ALL:%=build/nebula-%.tar.gz)

release-linux: $(ALL_LINUX:%=build/nebula-%.tar.gz)

release-freebsd: build/nebula-freebsd-amd64.tar.gz

BUILD_ARGS = -trimpath

bin-windows: build/windows-amd64/nebula.exe build/windows-amd64/nebula-cert.exe
	mv $? .

bin-windows-arm64: build/windows-arm64/nebula.exe build/windows-arm64/nebula-cert.exe
	mv $? .

bin-darwin: build/darwin-amd64/nebula build/darwin-amd64/nebula-cert
	mv $? .

bin-freebsd: build/freebsd-amd64/nebula build/freebsd-amd64/nebula-cert
	mv $? .

bin:
	go build $(BUILD_ARGS) -ldflags "$(LDFLAGS)" -o ./nebula${NEBULA_CMD_SUFFIX} ${NEBULA_CMD_PATH}
	go build $(BUILD_ARGS) -ldflags "$(LDFLAGS)" -o ./nebula-cert${NEBULA_CMD_SUFFIX} ./cmd/nebula-cert

install:
	go install $(BUILD_ARGS) -ldflags "$(LDFLAGS)" ${NEBULA_CMD_PATH}
	go install $(BUILD_ARGS) -ldflags "$(LDFLAGS)" ./cmd/nebula-cert

build/linux-arm-%: GOENV += GOARM=$(word 3, $(subst -, ,$*))
build/linux-mips-%: GOENV += GOMIPS=$(word 3, $(subst -, ,$*))

# Build an extra small binary for mips-softfloat
build/linux-mips-softfloat/%: LDFLAGS += -s -w

build/%/nebula: .FORCE
	GOOS=$(firstword $(subst -, , $*)) \
		GOARCH=$(word 2, $(subst -, ,$*)) $(GOENV) \
		go build $(BUILD_ARGS) -o $@ -ldflags "$(LDFLAGS)" ${NEBULA_CMD_PATH}

build/%/nebula-cert: .FORCE
	GOOS=$(firstword $(subst -, , $*)) \
		GOARCH=$(word 2, $(subst -, ,$*)) $(GOENV) \
		go build $(BUILD_ARGS) -o $@ -ldflags "$(LDFLAGS)" ./cmd/nebula-cert

build/%/nebula.exe: build/%/nebula
	mv $< $@

build/%/nebula-cert.exe: build/%/nebula-cert
	mv $< $@

build/nebula-%.tar.gz: build/%/nebula build/%/nebula-cert
	tar -zcv -C build/$* -f $@ nebula nebula-cert

build/nebula-%.zip: build/%/nebula.exe build/%/nebula-cert.exe
	cd build/$* && zip ../nebula-$*.zip nebula.exe nebula-cert.exe

vet:
	go vet -v ./...

test:
	go test -v ./...

test-cov-html:
	go test -coverprofile=coverage.out
	go tool cover -html=coverage.out

bench:
	go test -bench=.

bench-cpu:
	go test -bench=. -benchtime=5s -cpuprofile=cpu.pprof
	go tool pprof go-audit.test cpu.pprof

bench-cpu-long:
	go test -bench=. -benchtime=60s -cpuprofile=cpu.pprof
	go tool pprof go-audit.test cpu.pprof

proto: nebula.pb.go cert/cert.pb.go

nebula.pb.go: nebula.proto .FORCE
	go build github.com/gogo/protobuf/protoc-gen-gogofaster
	PATH="$(CURDIR):$(PATH)" protoc --gogofaster_out=paths=source_relative:. $<
	rm protoc-gen-gogofaster

cert/cert.pb.go: cert/cert.proto .FORCE
	$(MAKE) -C cert cert.pb.go

service:
	@echo > $(NULL_FILE)
	$(eval NEBULA_CMD_PATH := "./cmd/nebula-service")
ifeq ($(words $(MAKECMDGOALS)),1)
	@$(MAKE) service ${.DEFAULT_GOAL} --no-print-directory
endif

bin-docker: bin build/linux-amd64/nebula build/linux-amd64/nebula-cert

smoke-docker: bin-docker
	cd .github/workflows/smoke/ && ./build.sh
	cd .github/workflows/smoke/ && ./smoke.sh

smoke-relay-docker: bin-docker
	cd .github/workflows/smoke/ && ./build-relay.sh
	cd .github/workflows/smoke/ && ./smoke-relay.sh

smoke-docker-race: BUILD_ARGS = -race
smoke-docker-race: smoke-docker

.FORCE:
.PHONY: e2e e2ev e2evv e2evvv e2evvvv test test-cov-html bench bench-cpu bench-cpu-long bin proto release service smoke-docker smoke-docker-race
.DEFAULT_GOAL := bin

=== debian/changelog ===
nebula (1.6.1+dfsg-3) unstable; urgency=medium

  * Team upload.
  * Include version string when building nebula cli

 -- Peymaneh <peymaneh@posteo.net>  Sun, 18 Dec 2022 21:48:19 +0100

nebula (1.6.1+dfsg-2) unstable; urgency=medium

  * Team upload
  * Source only upload for testing migration

 -- Peymaneh <peymaneh@posteo.net>  Sun, 11 Dec 2022 16:12:04 +0100

nebula (1.6.1+dfsg-1) unstable; urgency=medium

  * Team Upload.
  * Upload to unstable (Closes: #1024961)

  [ Nilesh Patra ]
  * Add B-D on golang-github-skip2-go-qrcode-dev instead

  [ Peymaneh ]
  * d/copyright,d/watch: make source package dfsg-compliant
  * d/gbp.conf: Filter: .gitignore, .github/
  * New upstream version 1.6.1+dfsg
  * d/control: Bump standards version
  * d/control: Update dependencies
  * Add development package golang-github-slackhq-nebula-dev
  * Add very simple autopkgtest for nebula cli
  * d/copyright: Add Wireguard LLC

 -- Peymaneh <peymaneh@posteo.net>  Wed, 07 Dec 2022 22:35:39 +0100

nebula (1.4.0-1) experimental; urgency=medium

  * Initial release (Closes: #990680)

 -- Alex David <flu0r1ne@flu0r1ne.net>  Sun, 18 Jul 2021 22:50:56 +0530

=== debian/control ===
Source: nebula
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders: Alex David <flu0r1ne@flu0r1ne.net>
Section: golang
Testsuite: autopkgtest-pkg-go
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-golang,
               golang-any,
               golang-github-skip2-go-qrcode-dev,
               golang-github-anmitsu-go-shlex-dev,
               golang-github-armon-go-radix-dev,
               golang-github-cyberdelia-go-metrics-graphite-dev,
               golang-github-imdario-mergo-dev,
               golang-github-kardianos-service-dev,
               golang-github-miekg-dns-dev,
               golang-github-stretchr-testify-dev,
               golang-github-vishvananda-netlink-dev,
               golang-github-nbrownus-go-metrics-prometheus-dev,
               golang-github-gogo-protobuf-dev,
               golang-github-flynn-noise-dev,
               golang-golang-x-crypto-dev,
               golang-golang-x-net-dev,
               golang-golang-x-sys-dev,
               golang-google-protobuf-dev,
               golang-logrus-dev,
               golang-github-rcrowley-go-metrics-dev,
               golang-github-prometheus-client-golang-dev,
               golang-yaml.v2-dev
Standards-Version: 4.6.1.0
Vcs-Browser: https://salsa.debian.org/go-team/packages/nebula
Vcs-Git: https://salsa.debian.org/go-team/packages/nebula.git
Homepage: https://github.com/slackhq/nebula
Rules-Requires-Root: no
XS-Go-Import-Path: github.com/slackhq/nebula

Package: nebula
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Built-Using: ${misc:Built-Using}
Description: performant, scalable network overlay
 Nebula is a scalable overlay networking tool with a focus on performance,
 simplicity and security. It is intended to be more robust than current virtual
 networking solutions by providing peer-to-peer connectivity and NAT traversal
 mechanisms. Nebula uses state-of-the-art cryptography based on the "Noise"
 protocol.
 .
 This package provide the binaries and default configuration for Nebula.

Package: golang-github-slackhq-nebula-dev
Architecture: all
Multi-Arch: foreign
Depends: golang-github-skip2-go-qrcode-dev,
         golang-github-anmitsu-go-shlex-dev,
         golang-github-armon-go-radix-dev,
         golang-github-cyberdelia-go-metrics-graphite-dev,
         golang-github-imdario-mergo-dev,
         golang-github-kardianos-service-dev,
         golang-github-miekg-dns-dev,
         golang-github-stretchr-testify-dev,
         golang-github-vishvananda-netlink-dev,
         golang-github-nbrownus-go-metrics-prometheus-dev,
         golang-gogoprotobuf-dev,
         golang-github-flynn-noise-dev,
         golang-golang-x-crypto-dev,
         golang-golang-x-net-dev,
         golang-golang-x-sys-dev,
         golang-google-protobuf-dev,
         golang-logrus-dev,
         golang-github-rcrowley-go-metrics-dev,
         golang-github-prometheus-client-golang-dev,
         golang-yaml.v2-dev,
         ${misc:Depends}
Description: performant, scalable network overlay (Go library)
 Nebula is a scalable overlay networking tool with a focus on performance,
 simplicity and security.
 .
 This package provides the source files as Go library.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Include version number
include /usr/share/dpkg/pkg-info.mk
VERSION = $(shell echo $(DEB_VERSION) | cut -d+ -f1)
LDFLAGS := '-X main.Build=$(VERSION)'

%:
	dh $@ --builddirectory=_build --buildsystem=golang --with=golang

override_dh_auto_build:
	dh_auto_build -- -ldflags $(LDFLAGS)

=== debian/tests/control ===
Tests: parse-cert
Depends: @

Tests: parse-config
Depends: @
Restrictions: needs-root, isolation-container

Tests: version
Depends: @

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%nebula-$1.tar.gz%,\
      repack,\
      repacksuffix=+dfsg,\
      dversionmangle=s/\+(debian|dfsg|ds|deb)(\.\d+)?$//, \
      uversionmangle=s/(\d)[_\.\-\+]?(RC|rc|pre|dev|beta|alpha)[.]?(\d*)$/\$1~\$2\$3/" \
  https://github.com/slackhq/nebula/tags .*/v?(\d\S*)\.tar\.gz debian

## nebula 1.9.3+dfsg

=== Makefile ===
--- 
+++ 
@@ -1,20 +1,14 @@
-GOMINVERSION = 1.18
 NEBULA_CMD_PATH = "./cmd/nebula"
-GO111MODULE = on
-export GO111MODULE
 CGO_ENABLED = 0
 export CGO_ENABLED
 
 # Set up OS specific bits
 ifeq ($(OS),Windows_NT)
-	#TODO: we should be able to ditch awk as well
-	GOVERSION := $(shell go version | awk "{print substr($$3, 3)}")
-	GOISMIN := $(shell IF "$(GOVERSION)" GEQ "$(GOMINVERSION)" ECHO 1)
 	NEBULA_CMD_SUFFIX = .exe
 	NULL_FILE = nul
+	# RIO on windows does pointer stuff that makes go vet angry
+	VET_FLAGS = -unsafeptr=false
 else
-	GOVERSION := $(shell go version | awk '{print substr($$3, 3)}')
-	GOISMIN := $(shell expr "$(GOVERSION)" ">=" "$(GOMINVERSION)")
 	NEBULA_CMD_SUFFIX =
 	NULL_FILE = /dev/null
 endif
@@ -27,6 +21,9 @@
 		BUILD_NUMBER = $(shell git describe --exact-match --dirty | cut -dv -f2)
 	endif
 endif
+
+DOCKER_IMAGE_REPO ?= nebulaoss/nebula
+DOCKER_IMAGE_TAG ?= latest
 
 LDFLAGS = -X main.Build=$(BUILD_NUMBER)
 
@@ -42,12 +39,24 @@
 	linux-mips64 \
 	linux-mips64le \
 	linux-mips-softfloat \
-	linux-riscv64
+	linux-riscv64 \
+        linux-loong64
+
+ALL_FREEBSD = freebsd-amd64 \
+	freebsd-arm64
+
+ALL_OPENBSD = openbsd-amd64 \
+	openbsd-arm64
+
+ALL_NETBSD = netbsd-amd64 \
+ 	netbsd-arm64
 
 ALL = $(ALL_LINUX) \
+	$(ALL_FREEBSD) \
+	$(ALL_OPENBSD) \
+	$(ALL_NETBSD) \
 	darwin-amd64 \
 	darwin-arm64 \
-	freebsd-amd64 \
 	windows-amd64 \
 	windows-arm64
 
@@ -69,13 +78,23 @@
 e2e-bench: TEST_FLAGS = -bench=. -benchmem -run=^$
 e2e-bench: e2e
 
+DOCKER_BIN = build/linux-amd64/nebula build/linux-amd64/nebula-cert
+
 all: $(ALL:%=build/%/nebula) $(ALL:%=build/%/nebula-cert)
 
+docker: docker/linux-$(shell go env GOARCH)
+
 release: $(ALL:%=build/nebula-%.tar.gz)
 
 release-linux: $(ALL_LINUX:%=build/nebula-%.tar.gz)
 
-release-freebsd: build/nebula-freebsd-amd64.tar.gz
+release-freebsd: $(ALL_FREEBSD:%=build/nebula-%.tar.gz)
+
+release-openbsd: $(ALL_OPENBSD:%=build/nebula-%.tar.gz)
+
+release-netbsd: $(ALL_NETBSD:%=build/nebula-%.tar.gz)
+
+release-boringcrypto: build/nebula-linux-$(shell go env GOARCH)-boringcrypto.tar.gz
 
 BUILD_ARGS = -trimpath
 
@@ -89,6 +108,12 @@
 	mv $? .
 
 bin-freebsd: build/freebsd-amd64/nebula build/freebsd-amd64/nebula-cert
+	mv $? .
+
+bin-freebsd-arm64: build/freebsd-arm64/nebula build/freebsd-arm64/nebula-cert
+	mv $? .
+
+bin-boringcrypto: build/linux-$(shell go env GOARCH)-boringcrypto/nebula build/linux-$(shell go env GOARCH)-boringcrypto/nebula-cert
 	mv $? .
 
 bin:
@@ -104,6 +129,10 @@
 
 # Build an extra small binary for mips-softfloat
 build/linux-mips-softfloat/%: LDFLAGS += -s -w
+
+# boringcrypto
+build/linux-amd64-boringcrypto/%: GOENV += GOEXPERIMENT=boringcrypto CGO_ENABLED=1
+build/linux-arm64-boringcrypto/%: GOENV += GOEXPERIMENT=boringcrypto CGO_ENABLED=1
 
 build/%/nebula: .FORCE
 	GOOS=$(firstword $(subst -, , $*)) \
@@ -127,15 +156,27 @@
 build/nebula-%.zip: build/%/nebula.exe build/%/nebula-cert.exe
 	cd build/$* && zip ../nebula-$*.zip nebula.exe nebula-cert.exe
 
+docker/%: build/%/nebula build/%/nebula-cert
+	docker build . $(DOCKER_BUILD_ARGS) -f docker/Dockerfile --platform "$(subst -,/,$*)" --tag "${DOCKER_IMAGE_REPO}:${DOCKER_IMAGE_TAG}" --tag "${DOCKER_IMAGE_REPO}:$(BUILD_NUMBER)"
+
 vet:
-	go vet -v ./...
+	go vet $(VET_FLAGS) -v ./...
 
 test:
 	go test -v ./...
+
+test-boringcrypto:
+	GOEXPERIMENT=boringcrypto CGO_ENABLED=1 go test -v ./...
 
 test-cov-html:
 	go test -coverprofile=coverage.out
 	go tool cover -html=coverage.out
+
+build-test-mobile:
+	GOARCH=amd64 GOOS=ios go build $(shell go list ./... | grep -v '/cmd/\|/examples/')
+	GOARCH=arm64 GOOS=ios go build $(shell go list ./... | grep -v '/cmd/\|/examples/')
+	GOARCH=amd64 GOOS=android go build $(shell go list ./... | grep -v '/cmd/\|/examples/')
+	GOARCH=arm64 GOOS=android go build $(shell go list ./... | grep -v '/cmd/\|/examples/')
 
 bench:
 	go test -bench=.
@@ -170,14 +211,21 @@
 smoke-docker: bin-docker
 	cd .github/workflows/smoke/ && ./build.sh
 	cd .github/workflows/smoke/ && ./smoke.sh
+	cd .github/workflows/smoke/ && NAME="smoke-p256" CURVE="P256" ./build.sh
+	cd .github/workflows/smoke/ && NAME="smoke-p256" ./smoke.sh
 
 smoke-relay-docker: bin-docker
 	cd .github/workflows/smoke/ && ./build-relay.sh
 	cd .github/workflows/smoke/ && ./smoke-relay.sh
 
 smoke-docker-race: BUILD_ARGS = -race
+smoke-docker-race: CGO_ENABLED = 1
 smoke-docker-race: smoke-docker
 
+smoke-vagrant/%: bin-docker build/%/nebula
+	cd .github/workflows/smoke/ && ./build.sh $*
+	cd .github/workflows/smoke/ && ./smoke-vagrant.sh $*
+
 .FORCE:
-.PHONY: e2e e2ev e2evv e2evvv e2evvvv test test-cov-html bench bench-cpu bench-cpu-long bin proto release service smoke-docker smoke-docker-race
+.PHONY: bench bench-cpu bench-cpu-long bin build-test-mobile e2e e2ev e2evv e2evvv e2evvvv proto release service smoke-docker smoke-docker-race test test-cov-html smoke-vagrant/%
 .DEFAULT_GOAL := bin

=== debian/changelog ===
nebula (1.9.3+dfsg-6) unstable; urgency=medium

  * Use 2nd recommended set of argon2 parameters, avoiding failures
    with memory-constrained devices like 32-bits architectures.
    The initial patch in version 1.9.3+dfsg-3 was lowering memory
    parameter without increasing iterations, a too weak combination.
  * Backport upstream patch that uses these defaults in tests.

 -- Jérémy Lal <kapouer@melix.org>  Thu, 24 Apr 2025 10:38:06 +0200

nebula (1.9.3+dfsg-5) unstable; urgency=medium

  * Pass skip correctly
  * Pass --buildsystem to dh_auto_build
  * Drop --builddirectory

 -- Jérémy Lal <kapouer@melix.org>  Sun, 13 Apr 2025 21:26:56 +0200

nebula (1.9.3+dfsg-4) unstable; urgency=medium

  * Skip TestService, because it tests an experimental
    part that is not used by nebula, and it fails on s390x.

 -- Jérémy Lal <kapouer@melix.org>  Sun, 13 Apr 2025 19:22:34 +0200

nebula (1.9.3+dfsg-3) unstable; urgency=medium

  * Add patch to avoid OOM on 32-bits archs, skip test

 -- Jérémy Lal <kapouer@melix.org>  Sun, 13 Apr 2025 16:44:51 +0200

nebula (1.9.3+dfsg-2) experimental; urgency=medium

  * patch: fix ftbfs on 32-bit archs

 -- Jérémy Lal <kapouer@melix.org>  Sat, 12 Apr 2025 12:51:53 +0200

nebula (1.9.3+dfsg-1) experimental; urgency=medium

  * Team upload.
  * patch: backport upstream fix for future ftbfs.
    Closes:#1078630.

  [ Utkarsh Gupta ]
  * New upstream version 1.9.3+dfsg.
  * Refresh d/patches.

  [ Nilesh Patra ]
  * Add builddep on gvisor
  * Update patch
  * Switch to full blown salsa CI

 -- Jérémy Lal <kapouer@melix.org>  Sat, 12 Apr 2025 11:44:39 +0200

=== debian/control ===
--- 
+++ 
@@ -11,6 +11,7 @@
                golang-github-anmitsu-go-shlex-dev,
                golang-github-armon-go-radix-dev,
                golang-github-cyberdelia-go-metrics-graphite-dev,
+               golang-gvisor-gvisor-dev,
                golang-github-imdario-mergo-dev,
                golang-github-kardianos-service-dev,
                golang-github-miekg-dns-dev,

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Include version number
include /usr/share/dpkg/pkg-info.mk
VERSION = $(shell echo $(DEB_VERSION) | cut -d+ -f1)
LDFLAGS := '-X main.Build=$(VERSION)'

# gvisor based service library is somewhat experimental,
# see https://github.com/slackhq/nebula/pull/965
# Also, it fails on s390x
SKIP_TESTS += TestService

%:
	dh $@ --buildsystem=golang --with=golang

override_dh_auto_build:
	dh_auto_build --buildsystem=golang -- -ldflags $(LDFLAGS)

override_dh_auto_test:
	dh_auto_test --buildsystem=golang -- -skip "$(subst $(eval ) ,|,$(SKIP_TESTS))"

## nebula 1.10.2+dfsg

=== debian/changelog ===
nebula (1.10.2+dfsg-1~exp0) experimental; urgency=medium

  * Team upload
  * New upstream version 1.10.2 (Closes: #1083128)
  * Use version v5 watch
  * Disable patches for now
  * Run wrap-and-sort
  * Add new dependencies
  * Add Static-Built-Using.
  * Standards-Version: 4.7.3
  * Drop Rules-Requires-Root: no
  * Drop Priority: optional
  * Use golang-1.25
  * Bump gaissmai/bart to 0.26.0
  * Add d/watch Dversion-Mangle
  * Add debian/* copyright years
  * Remove d/patches/

 -- Simon Josefsson <simon@josefsson.org>  Tue, 03 Feb 2026 09:52:03 +0100

=== debian/control ===
Source: nebula
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders: Alex David <flu0r1ne@flu0r1ne.net>
Section: golang
Testsuite: autopkgtest-pkg-go
Build-Depends: debhelper-compat (= 13),
               dh-golang,
               golang-1.25,
               golang-any,
               golang-github-anmitsu-go-shlex-dev,
               golang-github-armon-go-radix-dev,
               golang-github-cyberdelia-go-metrics-graphite-dev,
               golang-github-flynn-noise-dev,
               golang-github-gaissmai-bart-dev (>> 0.26.0~),
               golang-github-gogo-protobuf-dev,
               golang-github-google-gopacket-dev,
               golang-github-imdario-mergo-dev,
               golang-github-kardianos-service-dev,
               golang-github-miekg-dns-dev,
               golang-github-nbrownus-go-metrics-prometheus-dev,
               golang-github-prometheus-client-golang-dev,
               golang-github-rcrowley-go-metrics-dev,
               golang-github-skip2-go-qrcode-dev,
               golang-github-stefanberger-go-pkcs11uri-dev,
               golang-github-stretchr-testify-dev,
               golang-github-vishvananda-netlink-dev,
               golang-golang-x-crypto-dev,
               golang-golang-x-net-dev,
               golang-golang-x-sys-dev,
               golang-google-protobuf-dev,
               golang-gvisor-gvisor-dev,
               golang-logrus-dev,
               golang-yaml.v2-dev
Standards-Version: 4.7.3
Vcs-Browser: https://salsa.debian.org/go-team/packages/nebula
Vcs-Git: https://salsa.debian.org/go-team/packages/nebula.git
Homepage: https://github.com/slackhq/nebula
XS-Go-Import-Path: github.com/slackhq/nebula

Package: nebula
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Built-Using: ${misc:Built-Using}
Static-Built-Using: ${misc:Static-Built-Using}
Description: performant, scalable network overlay
 Nebula is a scalable overlay networking tool with a focus on performance,
 simplicity and security. It is intended to be more robust than current virtual
 networking solutions by providing peer-to-peer connectivity and NAT traversal
 mechanisms. Nebula uses state-of-the-art cryptography based on the "Noise"
 protocol.
 .
 This package provide the binaries and default configuration for Nebula.

Package: golang-github-slackhq-nebula-dev
Architecture: all
Multi-Arch: foreign
Depends: golang-github-anmitsu-go-shlex-dev,
         golang-github-armon-go-radix-dev,
         golang-github-cyberdelia-go-metrics-graphite-dev,
         golang-github-flynn-noise-dev,
         golang-github-gaissmai-bart-dev (>> 0.26.0~),
         golang-github-google-gopacket-dev,
         golang-github-imdario-mergo-dev,
         golang-github-kardianos-service-dev,
         golang-github-miekg-dns-dev,
         golang-github-nbrownus-go-metrics-prometheus-dev,
         golang-github-prometheus-client-golang-dev,
         golang-github-rcrowley-go-metrics-dev,
         golang-github-skip2-go-qrcode-dev,
         golang-github-stefanberger-go-pkcs11uri-dev,
         golang-github-stretchr-testify-dev,
         golang-github-vishvananda-netlink-dev,
         golang-gogoprotobuf-dev,
         golang-golang-x-crypto-dev,
         golang-golang-x-net-dev,
         golang-golang-x-sys-dev,
         golang-google-protobuf-dev,
         golang-logrus-dev,
         golang-yaml.v2-dev,
         ${misc:Depends}
Description: performant, scalable network overlay (Go library)
 Nebula is a scalable overlay networking tool with a focus on performance,
 simplicity and security.
 .
 This package provides the source files as Go library.

=== debian/watch ===
Version: 5
Template: Github
Owner: slackhq
Project: nebula
Repack: yes
Repacksuffix: +dfsg
Dversion-Mangle: s/\+dfsg\d*$//

## nebula 1.10.3+dfsg

=== Makefile ===
--- 
+++ 
@@ -40,7 +40,7 @@
 	linux-mips64le \
 	linux-mips-softfloat \
 	linux-riscv64 \
-        linux-loong64
+	linux-loong64
 
 ALL_FREEBSD = freebsd-amd64 \
 	freebsd-arm64
@@ -63,7 +63,7 @@
 e2e:
 	$(TEST_ENV) go test -tags=e2e_testing -count=1 $(TEST_FLAGS) ./e2e
 
-e2ev: TEST_FLAGS = -v
+e2ev: TEST_FLAGS += -v
 e2ev: e2e
 
 e2evv: TEST_ENV += TEST_LOGS=1
@@ -96,7 +96,7 @@
 
 release-boringcrypto: build/nebula-linux-$(shell go env GOARCH)-boringcrypto.tar.gz
 
-BUILD_ARGS = -trimpath
+BUILD_ARGS += -trimpath
 
 bin-windows: build/windows-amd64/nebula.exe build/windows-amd64/nebula-cert.exe
 	mv $? .
@@ -115,6 +115,10 @@
 
 bin-boringcrypto: build/linux-$(shell go env GOARCH)-boringcrypto/nebula build/linux-$(shell go env GOARCH)-boringcrypto/nebula-cert
 	mv $? .
+
+bin-pkcs11: BUILD_ARGS += -tags pkcs11
+bin-pkcs11: CGO_ENABLED = 1
+bin-pkcs11: bin
 
 bin:
 	go build $(BUILD_ARGS) -ldflags "$(LDFLAGS)" -o ./nebula${NEBULA_CMD_SUFFIX} ${NEBULA_CMD_PATH}
@@ -133,6 +137,8 @@
 # boringcrypto
 build/linux-amd64-boringcrypto/%: GOENV += GOEXPERIMENT=boringcrypto CGO_ENABLED=1
 build/linux-arm64-boringcrypto/%: GOENV += GOEXPERIMENT=boringcrypto CGO_ENABLED=1
+build/linux-amd64-boringcrypto/%: LDFLAGS += -checklinkname=0
+build/linux-arm64-boringcrypto/%: LDFLAGS += -checklinkname=0
 
 build/%/nebula: .FORCE
 	GOOS=$(firstword $(subst -, , $*)) \
@@ -166,7 +172,10 @@
 	go test -v ./...
 
 test-boringcrypto:
-	GOEXPERIMENT=boringcrypto CGO_ENABLED=1 go test -v ./...
+	GOEXPERIMENT=boringcrypto CGO_ENABLED=1 go test -ldflags "-checklinkname=0" -v ./...
+
+test-pkcs11:
+	CGO_ENABLED=1 go test -v -tags pkcs11 ./...
 
 test-cov-html:
 	go test -coverprofile=coverage.out
@@ -189,7 +198,7 @@
 	go test -bench=. -benchtime=60s -cpuprofile=cpu.pprof
 	go tool pprof go-audit.test cpu.pprof
 
-proto: nebula.pb.go cert/cert.pb.go
+proto: nebula.pb.go cert/cert_v1.pb.go
 
 nebula.pb.go: nebula.proto .FORCE
 	go build github.com/gogo/protobuf/protoc-gen-gogofaster

=== cert/Makefile ===
GO111MODULE = on
export GO111MODULE

cert_v1.pb.go: cert_v1.proto .FORCE
	go build google.golang.org/protobuf/cmd/protoc-gen-go
	PATH="$(CURDIR):$(PATH)" protoc --go_out=. --go_opt=paths=source_relative $<
	rm protoc-gen-go

.FORCE:

=== debian/changelog ===
nebula (1.10.3+dfsg-1) unstable; urgency=medium

  * Team upload
  * Use gbp sign-tags and upstream-vcs-tag
  * Add new dep golang-filippo-bigmod-dev
  * Fix parse-cert test

 -- Simon Josefsson <simon@josefsson.org>  Mon, 16 Feb 2026 09:48:36 +0100

nebula (1.10.2+dfsg-1) unstable; urgency=medium

  * Upload to unstable
  * Fix 32bit tests FTBFS
  * B-D on golang-1.25-go instead of golang-1.25 for loong64

 -- Simon Josefsson <simon@josefsson.org>  Wed, 04 Feb 2026 14:07:40 +0100

=== debian/control ===
--- 
+++ 
@@ -5,8 +5,9 @@
 Testsuite: autopkgtest-pkg-go
 Build-Depends: debhelper-compat (= 13),
                dh-golang,
-               golang-1.25,
+               golang-1.25-go,
                golang-any,
+               golang-filippo-bigmod-dev,
                golang-github-anmitsu-go-shlex-dev,
                golang-github-armon-go-radix-dev,
                golang-github-cyberdelia-go-metrics-graphite-dev,
@@ -54,7 +55,8 @@
 Package: golang-github-slackhq-nebula-dev
 Architecture: all
 Multi-Arch: foreign
-Depends: golang-github-anmitsu-go-shlex-dev,
+Depends: golang-filippo-bigmod-dev,
+         golang-github-anmitsu-go-shlex-dev,
          golang-github-armon-go-radix-dev,
          golang-github-cyberdelia-go-metrics-graphite-dev,
          golang-github-flynn-noise-dev,

=== debian/tests/control ===
Tests: parse-cert
Depends: @

Tests: parse-config
Depends: @
Restrictions: isolation-container, needs-root

Tests: version
Depends: @
